package client;

import client.view.IO;
import client.view.ResponseListener;
import controller.IdController;
import controller.MessageController;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class SimpleShell {
    private IO io;
    private IdController idController;
    private MessageController messageController;
    private Pattern regex;
    private List<String> history;
    private List<String> list;
    private String commandLine;

    public SimpleShell(){
        idController = new IdController();
        messageController = new MessageController();
        regex = Pattern.compile("[^\\s\"']+|\"([^\"]*)\"|'([^']*)'");
        history = new ArrayList<>();
        io = new IO();
    }
    public void start() {
        Thread listener = new Thread(new ResponseListener());
        listener.start();
        while (true) {
            try {
                getInput();

                if (commandLine.equals("")) continue;
                else if (commandLine.equals("exit")) {
                    io.print("bye!");
                    listener.interrupt();
                    break;
                }
                history.addAll(list);
                commandRouter();
            }
            catch (IOException e) {
                io.print("Input Error, Please try again!");
            }
        }
    }
    private void getInput() throws IOException {
        commandLine = io.input("cmd?");
        list = listMaker(commandLine, regex);
    }
    private List<String> listMaker(String input, Pattern p) {
        List<String> result = new ArrayList<>();
        Matcher m = p.matcher(input);
        while (m.find()) {
            result.add(m.group());
        }
        return result;
    }
    private void commandRouter() throws IOException {
        if (list.get(list.size() - 1).equals("history")) {
            io.printHistory(history);
        }
        //TODO: CALLING CONTROLLERS
        if (list.contains("ids")) {
            io.prettyPrint(idController.route(list));
        }
        else if (list.contains("messages") || list.contains("send")) {
            io.prettyPrint(messageController.route(list));
        }
        //TODO: CALLING CONTROLLERS
    }
}