package controller;

import access.YouAreEll;
import com.fasterxml.jackson.databind.ObjectMapper;
import model.Message;
import java.io.IOException;
import java.util.List;

public class MessageController implements Controller {
    private YouAreEll access = new YouAreEll();
    private ObjectMapper om = new ObjectMapper();
    private List<String> commands;
    private Message message;
    //--------------------------------------------------------------------------------------
    //master routing
    @Override
    public String route(List<String> commands) throws IOException {
        this.commands = commands;
        switch(commands.get(0)) {
            case "send":
                return routeSendMessages();
            case "messages":
                return routeGetMessages();
            default:
                return "";
        }
    }
    //--------------------------------------------------------------------------------------
    //sub routing
    private String routeGetMessages() {
        switch(commands.size()) {
            case 1:
                return listLastTwenty("");
            case 2:
                return listLastTwenty("/ids/" + commands.get(1));
            default:
                return "";
        }
    }
    private String routeSendMessages() throws IOException {
        switch(commands.size()) {
            case 3:
                message = new Message(commands.get(1), commands.get(2), "");
                break;
            case 5:
                message = new Message(commands.get(1), commands.get(2), commands.get(4));
        }
        return sendMessage("/ids/" + message.getFromid() + "/messages");
    }
    //--------------------------------------------------------------------------------------
    //access methods
    private String listLastTwenty(String name) {
        return access.get_messages(name + "/messages");
    }
    private String sendMessage(String url) throws IOException {
        return access.post_messages(url, om.writeValueAsString(message));
    }
}
